gtkmm: Gdk::Display Class Reference

gtkmm 2.24.5

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gdk::Display Class Reference

Gdk::Display object's purpose is two fold: To grab/ungrab keyboard focus and mouse pointer To manage and provide information about the Gdk::Screen(s) available for this Gdk::Display. More...

Inheritance diagram for Gdk::Display:
[legend]
Collaboration diagram for Gdk::Display:
[legend]

## Public Member Functions
| Display (Display&& src) noexcept
Display& | operator= (Display&& src) noexcept
| ~Display () noexcept override
GdkDisplay* | gobj ()
| Provides access to the underlying C GObject. More...
const GdkDisplay* | gobj () const
| Provides access to the underlying C GObject. More...
GdkDisplay* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | get_name () const
| Gets the name of the display. More...
int | get_n_screens () const
| Gets the number of screen managed by the display. More...
Glib::RefPtr< Screen > | get_screen (int screen_num)
| Returns a screen object for one of the screens of the display. More...
Glib::RefPtr< const Screen > | get_screen (int screen_num) const
| Returns a screen object for one of the screens of the display. More...
Glib::RefPtr< Screen > | get_default_screen ()
| Get the default Gdk::Screen for display. More...
Glib::RefPtr< const Screen > | get_default_screen () const
| Get the default Gdk::Screen for display. More...
void | pointer_ungrab (guint32 timestamp)
| Release any pointer grab. More...
void | keyboard_ungrab (guint32 timestamp)
| Release any keyboard grab. More...
bool | pointer_is_grabbed () const
| Test if the pointer is grabbed. More...
void | beep ()
| Emits a short beep on display. More...
void | sync ()
| Flushes any requests queued for the windowing system and waits until all requests have been handled. More...
void | close ()
| Closes the connection to the windowing system for the given display, and cleans up associated resources. More...
Glib::ListHandle< Glib::RefPtr< Device > > | list_devices ()
| Returns the list of available input devices attached to display. More...
Glib::ListHandle< Glib::RefPtr< const Device > > | list_devices () const
| Returns the list of available input devices attached to display. More...
GdkEvent* | get_event ()
| Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary. More...
const GdkEvent* | get_event () const
| Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary. More...
GdkEvent* | peek_event ()
| Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue. More...
GdkEvent* | peek_event () const
| Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue. More...
void | put_event (GdkEvent* event)
| Appends a copy of the given event onto the front of the event queue for display. More...
void | add_client_message_filter (Glib::ustring& message_type, GdkFilterFunc func, gpointer data)
| Adds a filter to be called when X ClientMessage events are received. More...
void | set_double_click_time (guint msec)
| Sets the double click time (two clicks within this time interval count as a double click and result in a Gdk::2BUTTON_PRESS event). More...
void | set_double_click_distance (guint distance)
| Sets the double click distance (two clicks within this distance count as a double click and result in a Gdk::2BUTTON_PRESS event). More...
Glib::RefPtr< Device > | get_core_pointer ()
| Returns the core pointer device for the given display. More...
Glib::RefPtr< const Device > | get_core_pointer () const
| Returns the core pointer device for the given display. More...
void | get_pointer (Glib::RefPtr< Screen >& screen, int& x, int& y, ModifierType& mask)
| Gets the current location of the pointer and the current modifier mask for a given display. More...
void | get_pointer (int& x, int& y, ModifierType& mask)
| Gets the current location of the pointer and the current modifier mask for a given display. More...
Glib::RefPtr< Window > | get_window_at_pointer (int& win_x, int& win_y)
| Obtains the window underneath the mouse pointer, returning the location of the pointer in that window in win_x, win_y for screen. More...
Glib::RefPtr< const Window > | get_window_at_pointer (int& win_x, int& win_y) const
| Obtains the window underneath the mouse pointer, returning the location of the pointer in that window in win_x, win_y for screen. More...
Glib::RefPtr< Window > | get_window_at_pointer ()
| Obtains the window underneath the mouse pointer. More...
Glib::RefPtr< const Window > | get_window_at_pointer () const
| Obtains the window underneath the mouse pointer. More...
void | warp_pointer (const Glib::RefPtr< Screen >& screen, int x, int y)
| Warps the pointer of display to the point x, y on the screen screen, unless the pointer is confined to a window by a grab, in which case it will be moved as far as allowed by the grab. More...
GdkDisplayPointerHooks* | set_pointer_hooks (const GdkDisplayPointerHooks* new_hooks)
| This function allows for hooking into the operation of getting the current location of the pointer on a particular display. More...
GdkDisplayPointerHooks* | unset_pointer_hooks ()
GdkNativeWindow | get_drag_protocol (GdkNativeWindow xid, GdkDragProtocol& protocol)
| Finds out the DND protocol supported by a window. More...
GdkKeymap* | get_keymap ()
| Returns the Gdk::Keymap attached to display. More...
const GdkKeymap* | get_keymap () const
| Returns the Gdk::Keymap attached to display. More...
bool | set_selection_owner (const Glib::RefPtr< Window >& owner, Glib::ustring& selection, guint32 time_, bool send_event)
Glib::RefPtr< Window > | get_selection_owner (const Glib::ustring& selection)
void | selection_send_notify (GdkNativeWindow requestor, Glib::ustring& selection, Glib::ustring& target, Glib::ustring& property, guint32 time_)
| Send a response to SelectionRequest event. More...
Glib::RefPtr< Pixmap > | lookup_pixmap (NativeWindow anid)
| Looks up the Gdk::Pixmap that wraps the given native pixmap handle. More...
Glib::RefPtr< const Pixmap > | lookup_pixmap (NativeWindow anid) const
| Looks up the Gdk::Pixmap that wraps the given native pixmap handle. More...
void | flush ()
| Flushes any requests queued for the windowing system; this happens automatically when the main loop blocks waiting for new events, but if your application is drawing without returning control to the main loop, you may need to call this function explicitely. More...
bool | supports_cursor_alpha () const
| Returns `true` if cursors can use an 8bit alpha channel on display. More...
bool | supports_cursor_color () const
| Returns `true` if multicolored cursors are supported on display. More...
guint | get_default_cursor_size () const
| Returns the default size to use for cursors on display. More...
void | get_maximal_cursor_size (guint& width, guint& height)
| Gets the maximal size to use for cursors on display. More...
Glib::RefPtr< Window > | get_default_group ()
| Returns the default group leader window for all toplevel windows on display. More...
Glib::RefPtr< const Window > | get_default_group () const
| Returns the default group leader window for all toplevel windows on display. More...
bool | supports_selection_notification () const
| Returns whether Gdk::EventOwnerChange events will be sent when the owner of a selection changes. More...
bool | request_selection_notification (const Glib::ustring& selection)
| Request Gdk::EventOwnerChange events for ownership changes of the selection named by the given atom. More...
bool | supports_clipboard_persistence () const
| Returns whether the speicifed display supports clipboard persistance; i.e. if it's possible to store the clipboard data after an application has quit. More...
void | store_clipboard (const Glib::RefPtr< Gdk::Window >& clipboard_window, guint32 time_)
| Issues a request to the clipboard manager to store the clipboard data, saving all available targets. More...
void | store_clipboard (const Glib::RefPtr< Gdk::Window >& clipboard_window, guint32 time_, const Glib::StringArrayHandle& targets)
bool | supports_shapes () const
| Returns `true` if Gdk::Window::shape_combine_mask() can be used to create shaped windows on display. More...
bool | supports_input_shapes () const
| Returns `true` if Gdk::Window::input_shape_combine_mask() can be used to modify the input shape of windows on display. More...
bool | supports_composite () const
| Returns `true` if Gdk::Window::set_composited() can be used to redirect drawing on the window using compositing. More...
Glib::SignalProxy< void, bool > | signal_closed ()
| The closed signal is emitted when the connection to the windowing system for this display is closed. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Display > | open (const Glib::ustring& display_name)
| Opens a display. More...
static Glib::RefPtr< Display > | get_default ()
| Gets the default Gdk::Display. More...
static Glib::RefPtr< Display > | open_default_libgtk_only ()
| Opens the default display specified by command line arguments or environment variables, sets it as the default display, and returns it. More...

## Protected Member Functions
| Display ()
virtual void | on_closed (bool is_error)
| This is a default handler for the signal signal_closed(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::Display > | wrap (GdkDisplay* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Gdk::Display object's purpose is two fold: To grab/ungrab keyboard focus and mouse pointer To manage and provide information about the Gdk::Screen(s) available for this Gdk::Display.

Gdk::Display objects are the GDK representation of the X Display which can be described as a workstation consisting of a keyboard a pointing device (such as a mouse) and one or more screens. It is used to open and keep track of various Gdk::Screen objects currently instantiated by the application. It is also used to grab and release the keyboard and the mouse pointer.

## Constructor & Destructor Documentation

## ◆ Display() [1/2]

Gdk::Display::Display | ( | Display&& | src | ) |
| noexcept

## ◆ ~Display()

Gdk::Display::~Display | ( |  | ) |
| overridenoexcept

## ◆ Display() [2/2]

Gdk::Display::Display | ( |  | ) |
| protected

## Member Function Documentation

## ◆ add_client_message_filter()

void Gdk::Display::add_client_message_filter | ( | Glib::ustring & | message_type,
|  | GdkFilterFunc | func,
|  | gpointer | data
| ) |  |

Adds a filter to be called when X ClientMessage events are received.

See Gdk::Window::add_filter() if you are interested in filtering other types of events.

Since gtkmm 2.2:

Parameters

  message_type | The type of ClientMessage events to receive. This will be checked against the message_type field of the XClientMessage event struct.
  func | The function to call to process the event.
  data | User data to pass to func.

## ◆ beep()

void Gdk::Display::beep | ( |  | ) |

Emits a short beep on display.

Since gtkmm 2.2:

## ◆ close()

void Gdk::Display::close | ( |  | ) |

Closes the connection to the windowing system for the given display, and cleans up associated resources.

Since gtkmm 2.2:

## ◆ flush()

void Gdk::Display::flush | ( |  | ) |

Flushes any requests queued for the windowing system; this happens automatically when the main loop blocks waiting for new events, but if your application is drawing without returning control to the main loop, you may need to call this function explicitely.

A common case where this function needs to be called is when an application is executing drawing commands from a thread other than the thread where the main loop is running.

This is most useful for X11. On windowing systems where requests are handled synchronously, this function will do nothing.

Since gtkmm 2.4:

## ◆ get_core_pointer() [1/2]

Glib::RefPtr<Device> Gdk::Display::get_core_pointer | ( |  | ) |

Returns the core pointer device for the given display.

Since gtkmm 2.2:

Returns
  The core pointer device; this is owned by the display and should not be freed.

## ◆ get_core_pointer() [2/2]

Glib::RefPtr<const Device> Gdk::Display::get_core_pointer | ( |  | ) | const

Returns the core pointer device for the given display.

Since gtkmm 2.2:

Returns
  The core pointer device; this is owned by the display and should not be freed.

## ◆ get_default()

static Glib::RefPtr<Display> Gdk::Display::get_default | ( |  | ) |
| static

Gets the default Gdk::Display.

This is a convenience function for `gdk_display_manager_get_default_display (manager_get())`.

Since gtkmm 2.2:

Returns
  A Gdk::Display, or `nullptr` if there is no default display.

## ◆ get_default_cursor_size()

guint Gdk::Display::get_default_cursor_size | ( |  | ) | const

Returns the default size to use for cursors on display.

Since gtkmm 2.4:

Returns
  The default cursor size.

## ◆ get_default_group() [1/2]

Glib::RefPtr<Window> Gdk::Display::get_default_group | ( |  | ) |

Returns the default group leader window for all toplevel windows on display.

This window is implicitly created by GDK. See Gdk::Window::set_group().

Since gtkmm 2.4:

Returns
  The default group leader window for display.

## ◆ get_default_group() [2/2]

Glib::RefPtr<const Window> Gdk::Display::get_default_group | ( |  | ) | const

Returns the default group leader window for all toplevel windows on display.

This window is implicitly created by GDK. See Gdk::Window::set_group().

Since gtkmm 2.4:

Returns
  The default group leader window for display.

## ◆ get_default_screen() [1/2]

Glib::RefPtr<Screen> Gdk::Display::get_default_screen | ( |  | ) |

Get the default Gdk::Screen for display.

Since gtkmm 2.2:

Returns
  The default Gdk::Screen object for display.

## ◆ get_default_screen() [2/2]

Glib::RefPtr<const Screen> Gdk::Display::get_default_screen | ( |  | ) | const

Get the default Gdk::Screen for display.

Since gtkmm 2.2:

Returns
  The default Gdk::Screen object for display.

## ◆ get_drag_protocol()

GdkNativeWindow Gdk::Display::get_drag_protocol | ( | GdkNativeWindow | xid,
|  | GdkDragProtocol & | protocol
| ) |  |

Finds out the DND protocol supported by a window.

Since gtkmm 2.2:

Parameters

  xid | The windowing system id of the destination window.
  protocol | Location where the supported DND protocol is returned.

Returns
  The windowing system id of the window where the drop should happen. This may be xid or the id of a proxy window, or zero if xid doesn't support Drag and Drop.

## ◆ get_event() [1/2]

GdkEvent* Gdk::Display::get_event | ( |  | ) |

Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary.

Since gtkmm 2.2:

Returns
  The next Gdk::Event to be processed, or `nullptr` if no events are pending. The returned Gdk::Event should be freed with Gdk::Event::free().

## ◆ get_event() [2/2]

const GdkEvent* Gdk::Display::get_event | ( |  | ) | const

Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary.

Since gtkmm 2.2:

Returns
  The next Gdk::Event to be processed, or `nullptr` if no events are pending. The returned Gdk::Event should be freed with Gdk::Event::free().

## ◆ get_keymap() [1/2]

GdkKeymap* Gdk::Display::get_keymap | ( |  | ) |

Returns the Gdk::Keymap attached to display.

Since gtkmm 2.2:

Returns
  The Gdk::Keymap attached to display.

## ◆ get_keymap() [2/2]

const GdkKeymap* Gdk::Display::get_keymap | ( |  | ) | const

Returns the Gdk::Keymap attached to display.

Since gtkmm 2.2:

Returns
  The Gdk::Keymap attached to display.

## ◆ get_maximal_cursor_size()

void Gdk::Display::get_maximal_cursor_size | ( | guint & | width,
|  | guint & | height
| ) |  |

Gets the maximal size to use for cursors on display.

Since gtkmm 2.4:

Parameters

  width | The return location for the maximal cursor width.
  height | The return location for the maximal cursor height.

## ◆ get_n_screens()

int Gdk::Display::get_n_screens | ( |  | ) | const

Gets the number of screen managed by the display.

Since gtkmm 2.2:

Returns
  Number of screens.

## ◆ get_name()

Glib::ustring Gdk::Display::get_name | ( |  | ) | const

Gets the name of the display.

Since gtkmm 2.2:

Returns
  A string representing the display name. This string is owned by GDK and should not be modified or freed.

## ◆ get_pointer() [1/2]

void Gdk::Display::get_pointer | ( | Glib::RefPtr< Screen >& | screen,
|  | int & | x,
|  | int & | y,
|  | ModifierType& | mask
| ) |  |

Gets the current location of the pointer and the current modifier mask for a given display.

Parameters

  screen | location to store the screen that the cursor is on.
  x | location to store root window X coordinate of pointer.
  y | location to store root window Y coordinate of pointer.
  mask | location to store current modifier mask.

## ◆ get_pointer() [2/2]

void Gdk::Display::get_pointer | ( | int & | x,
|  | int & | y,
|  | ModifierType& | mask
| ) |  |

Gets the current location of the pointer and the current modifier mask for a given display.

Parameters

  x | location to store root window X coordinate of pointer.
  y | location to store root window Y coordinate of pointer.
  mask | location to store current modifier mask.

## ◆ get_screen() [1/2]

Glib::RefPtr<Screen> Gdk::Display::get_screen | ( | int | screen_num | ) |

Returns a screen object for one of the screens of the display.

Since gtkmm 2.2:

Parameters

  screen_num | The screen number.

Returns
  The Gdk::Screen object.

## ◆ get_screen() [2/2]

Glib::RefPtr<const Screen> Gdk::Display::get_screen | ( | int | screen_num | ) | const

Returns a screen object for one of the screens of the display.

Since gtkmm 2.2:

Parameters

  screen_num | The screen number.

Returns
  The Gdk::Screen object.

## ◆ get_selection_owner()

Glib::RefPtr<Window> Gdk::Display::get_selection_owner | ( | const Glib::ustring & | selection | ) |

## ◆ get_type()

static GType Gdk::Display::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_window_at_pointer() [1/4]

Glib::RefPtr<Window> Gdk::Display::get_window_at_pointer | ( | int & | win_x,
|  | int & | win_y
| ) |  |

Obtains the window underneath the mouse pointer, returning the location of the pointer in that window in win_x, win_y for screen.

Returns `nullptr` if the window under the mouse pointer is not known to GDK (for example, belongs to another application).

Since gtkmm 2.2:

Parameters

  win_x | Return location for x coordinate of the pointer location relative to the window origin, or `nullptr`.
  win_y | Return location for y coordinate of the pointer location relative & to the window origin, or `nullptr`.

Returns
  The window under the mouse pointer, or `nullptr`.

## ◆ get_window_at_pointer() [2/4]

Glib::RefPtr<const Window> Gdk::Display::get_window_at_pointer | ( | int & | win_x,
|  | int & | win_y
| ) |  | const

Obtains the window underneath the mouse pointer, returning the location of the pointer in that window in win_x, win_y for screen.

Returns `nullptr` if the window under the mouse pointer is not known to GDK (for example, belongs to another application).

Since gtkmm 2.2:

Parameters

  win_x | Return location for x coordinate of the pointer location relative to the window origin, or `nullptr`.
  win_y | Return location for y coordinate of the pointer location relative & to the window origin, or `nullptr`.

Returns
  The window under the mouse pointer, or `nullptr`.

## ◆ get_window_at_pointer() [3/4]

Glib::RefPtr<Window> Gdk::Display::get_window_at_pointer | ( |  | ) |

Obtains the window underneath the mouse pointer.

Returns a null RefPtr if the window under the mouse pointer is not known to GDK (for example, belongs to another application).

Returns
  The window underneath the mouse pointer.

## ◆ get_window_at_pointer() [4/4]

Glib::RefPtr<const Window> Gdk::Display::get_window_at_pointer | ( |  | ) | const

Obtains the window underneath the mouse pointer.

Returns a null RefPtr if the window under the mouse pointer is not known to GDK (for example, belongs to another application).

Returns
  The window underneath the mouse pointer.

## ◆ gobj() [1/2]

GdkDisplay* Gdk::Display::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkDisplay* Gdk::Display::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkDisplay* Gdk::Display::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ keyboard_ungrab()

void Gdk::Display::keyboard_ungrab | ( | guint32 | timestamp | ) |

Release any keyboard grab.

Since gtkmm 2.2:

Parameters

  timestamp | A timestap (e.g Gdk::CURRENT_TIME).

## ◆ list_devices() [1/2]

Glib::ListHandle< Glib::RefPtr<Device> > Gdk::Display::list_devices | ( |  | ) |

Returns the list of available input devices attached to display.

The list is statically allocated and should not be freed.

Since gtkmm 2.2:

Returns
  A list of Gdk::Device.

## ◆ list_devices() [2/2]

Glib::ListHandle< Glib::RefPtr<const Device> > Gdk::Display::list_devices | ( |  | ) | const

Returns the list of available input devices attached to display.

The list is statically allocated and should not be freed.

Since gtkmm 2.2:

Returns
  A list of Gdk::Device.

## ◆ lookup_pixmap() [1/2]

Glib::RefPtr<Pixmap> Gdk::Display::lookup_pixmap | ( | NativeWindow | anid | ) |

Looks up the Gdk::Pixmap that wraps the given native pixmap handle.

For example in the X backend, a native pixmap handle is an Xlib <type>XID</type>.

Since gtkmm 2.2:

Parameters

  anid | A native pixmap handle.

Returns
  The Gdk::Pixmap wrapper for the native pixmap, or `nullptr` if there is none.

## ◆ lookup_pixmap() [2/2]

Glib::RefPtr<const Pixmap> Gdk::Display::lookup_pixmap | ( | NativeWindow | anid | ) | const

Looks up the Gdk::Pixmap that wraps the given native pixmap handle.

For example in the X backend, a native pixmap handle is an Xlib <type>XID</type>.

Since gtkmm 2.2:

Parameters

  anid | A native pixmap handle.

Returns
  The Gdk::Pixmap wrapper for the native pixmap, or `nullptr` if there is none.

## ◆ on_closed()

virtual void Gdk::Display::on_closed | ( | bool | is_error | ) |
| protectedvirtual

This is a default handler for the signal signal_closed().

## ◆ open()

static Glib::RefPtr<Display> Gdk::Display::open | ( | const Glib::ustring & | display_name | ) |
| static

Opens a display.

Since gtkmm 2.2:

Parameters

  display_name | The name of the display to open.

Returns
  A Gdk::Display, or `nullptr` if the display could not be opened.

## ◆ open_default_libgtk_only()

static Glib::RefPtr<Display> Gdk::Display::open_default_libgtk_only | ( |  | ) |
| static

Opens the default display specified by command line arguments or environment variables, sets it as the default display, and returns it.

gdk_parse_args must have been called first. If the default display has previously been set, simply returns that. An internal function that should not be used by applications.

Returns
  The default display, if it could be opened, otherwise `nullptr`.

## ◆ operator=()

Display& Gdk::Display::operator= | ( | Display&& | src | ) |
| noexcept

## ◆ peek_event() [1/2]

GdkEvent* Gdk::Display::peek_event | ( |  | ) |

Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue.

(Note that this function will not get more events from the windowing system. It only checks the events that have already been moved to the GDK event queue.)

Since gtkmm 2.2:

Returns
  A copy of the first Gdk::Event on the event queue, or `nullptr` if no events are in the queue. The returned Gdk::Event should be freed with Gdk::Event::free().

## ◆ peek_event() [2/2]

GdkEvent* Gdk::Display::peek_event | ( |  | ) | const

Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue.

(Note that this function will not get more events from the windowing system. It only checks the events that have already been moved to the GDK event queue.)

Since gtkmm 2.2:

Returns
  A copy of the first Gdk::Event on the event queue, or `nullptr` if no events are in the queue. The returned Gdk::Event should be freed with Gdk::Event::free().

## ◆ pointer_is_grabbed()

bool Gdk::Display::pointer_is_grabbed | ( |  | ) | const

Test if the pointer is grabbed.

Since gtkmm 2.2:

Returns
  `true` if an active X pointer grab is in effect.

## ◆ pointer_ungrab()

void Gdk::Display::pointer_ungrab | ( | guint32 | timestamp | ) |

Release any pointer grab.

Since gtkmm 2.2:

Parameters

  timestamp | A timestap (e.g. GDK_CURRENT_TIME).

## ◆ put_event()

void Gdk::Display::put_event | ( | GdkEvent * | event | ) |

Appends a copy of the given event onto the front of the event queue for display.

Since gtkmm 2.2:

Parameters

  event | A Gdk::Event.

## ◆ request_selection_notification()

bool Gdk::Display::request_selection_notification | ( | const Glib::ustring & | selection | ) |

Request Gdk::EventOwnerChange events for ownership changes of the selection named by the given atom.

Since gtkmm 2.6:

Parameters

  selection | The Gdk::Atom naming the selection for which ownership change notification is requested.

Returns
  Whether Gdk::EventOwnerChange events will be sent.

## ◆ selection_send_notify()

void Gdk::Display::selection_send_notify | ( | GdkNativeWindow | requestor,
|  | Glib::ustring & | selection,
|  | Glib::ustring & | target,
|  | Glib::ustring & | property,
|  | guint32 | time_
| ) |  |

Send a response to SelectionRequest event.

Since gtkmm 2.2:

Parameters

  requestor | Window to which to deliver response.
  selection | Selection that was requested.
  target | Target that was selected.
  property | Property in which the selection owner stored the data, or "None" to indicate that the request was rejected.
  time_ | Timestamp.

## ◆ set_double_click_distance()

void Gdk::Display::set_double_click_distance | ( | guint | distance | ) |

Sets the double click distance (two clicks within this distance count as a double click and result in a Gdk::2BUTTON_PRESS event).

See also set_double_click_time(). Applications should not set this, it is a global user-configured setting.

Since gtkmm 2.4:

Parameters

  distance | Distance in pixels.

## ◆ set_double_click_time()

void Gdk::Display::set_double_click_time | ( | guint | msec | ) |

Sets the double click time (two clicks within this time interval count as a double click and result in a Gdk::2BUTTON_PRESS event).

Applications should not set this, it is a global user-configured setting.

Since gtkmm 2.2:

Parameters

  msec | Double click time in milliseconds (thousandths of a second).

## ◆ set_pointer_hooks()

GdkDisplayPointerHooks* Gdk::Display::set_pointer_hooks | ( | const GdkDisplayPointerHooks * | new_hooks | ) |

This function allows for hooking into the operation of getting the current location of the pointer on a particular display.

This is only useful for such low-level tools as an event recorder. Applications should never have any reason to use this facility.

Since gtkmm 2.2:

Parameters

  new_hooks | A table of pointers to functions for getting quantities related to the current pointer position.

Returns
  The previous pointer hook table.

## ◆ set_selection_owner()

bool Gdk::Display::set_selection_owner | ( | const Glib::RefPtr< Window >& | owner,
|  | Glib::ustring & | selection,
|  | guint32 | time_,
|  | bool | send_event
| ) |  |

## ◆ signal_closed()

Glib::SignalProxy< void,bool > Gdk::Display::signal_closed | ( |  | ) |

The closed signal is emitted when the connection to the windowing system for this display is closed.

Parameters

  is_error | true if the display was closed due to an error

Slot Prototype:
  `void on_my_closed(bool is_error)`

## ◆ store_clipboard() [1/2]

void Gdk::Display::store_clipboard | ( | const Glib::RefPtr< Gdk::Window >& | clipboard_window,
|  | guint32 | time_
| ) |  |

Issues a request to the clipboard manager to store the clipboard data, saving all available targets.

On X11, this is a special program that works according to the freedesktop clipboard specification, available at http://www.freedesktop.org/Standards/clipboard-manager-spec.

Since gtkmm 2.6:

Parameters

  clipboard_window | A Gdk::Window belonging to the clipboard owner.
  time_ | A timestamp.

## ◆ store_clipboard() [2/2]

void Gdk::Display::store_clipboard | ( | const Glib::RefPtr< Gdk::Window >& | clipboard_window,
|  | guint32 | time_,
|  | const Glib::StringArrayHandle & | targets
| ) |  |

## ◆ supports_clipboard_persistence()

bool Gdk::Display::supports_clipboard_persistence | ( |  | ) | const

Returns whether the speicifed display supports clipboard persistance; i.e. if it's possible to store the clipboard data after an application has quit.

On X11 this checks if a clipboard daemon is running.

Since gtkmm 2.6:

Returns
  `true` if the display supports clipboard persistance.

## ◆ supports_composite()

bool Gdk::Display::supports_composite | ( |  | ) | const

Returns `true` if Gdk::Window::set_composited() can be used to redirect drawing on the window using compositing.

Currently this only works on X11 with XComposite and XDamage extensions available.

Since gtkmm 2.12:

Returns
  `true` if windows may be composited.

## ◆ supports_cursor_alpha()

bool Gdk::Display::supports_cursor_alpha | ( |  | ) | const

Returns `true` if cursors can use an 8bit alpha channel on display.

Otherwise, cursors are restricted to bilevel alpha (i.e. a mask).

Since gtkmm 2.4:

Returns
  Whether cursors can have alpha channels.

## ◆ supports_cursor_color()

bool Gdk::Display::supports_cursor_color | ( |  | ) | const

Returns `true` if multicolored cursors are supported on display.

Otherwise, cursors have only a forground and a background color.

Since gtkmm 2.4:

Returns
  Whether cursors can have multiple colors.

## ◆ supports_input_shapes()

bool Gdk::Display::supports_input_shapes | ( |  | ) | const

Returns `true` if Gdk::Window::input_shape_combine_mask() can be used to modify the input shape of windows on display.

Since gtkmm 2.10:

Returns
  `true` if windows with modified input shape are supported.

## ◆ supports_selection_notification()

bool Gdk::Display::supports_selection_notification | ( |  | ) | const

Returns whether Gdk::EventOwnerChange events will be sent when the owner of a selection changes.

Since gtkmm 2.6:

Returns
  Whether Gdk::EventOwnerChange events will be sent.

## ◆ supports_shapes()

bool Gdk::Display::supports_shapes | ( |  | ) | const

Returns `true` if Gdk::Window::shape_combine_mask() can be used to create shaped windows on display.

Since gtkmm 2.10:

Returns
  `true` if shaped windows are supported.

## ◆ sync()

void Gdk::Display::sync | ( |  | ) |

Flushes any requests queued for the windowing system and waits until all requests have been handled.

This is often used for making sure that the display is synchronized with the current state of the program. Calling sync() before gdk_error_trap_pop() makes sure that any errors generated from earlier requests are handled before the error trap is removed.

This is most useful for X11. On windowing systems where requests are handled synchronously, this function will do nothing.

Since gtkmm 2.2:

## ◆ unset_pointer_hooks()

GdkDisplayPointerHooks* Gdk::Display::unset_pointer_hooks | ( |  | ) |

Deprecated:
  This method has been removed in gtkmm-3.0 for lack of use cases.

## ◆ warp_pointer()

void Gdk::Display::warp_pointer | ( | const Glib::RefPtr< Screen >& | screen,
|  | int | x,
|  | int | y
| ) |  |

Warps the pointer of display to the point x, y on the screen screen, unless the pointer is confined to a window by a grab, in which case it will be moved as far as allowed by the grab.

Warping the pointer creates events as if the user had moved the mouse instantaneously to the destination.

Note that the pointer should normally be under the control of the user. This function was added to cover some rare use cases like keyboard navigation support for the color picker in the Gtk::ColorSelectionDialog.

Since gtkmm 2.8:

Parameters

  screen | The screen of display to warp the pointer to.
  x | The x coordinate of the destination.
  y | The y coordinate of the destination.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::Display > wrap | ( | GdkDisplay * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/display.h